searchData={"items":[{"type":"behaviour","title":"SpiderMan","doc":"SpiderMan, a fast high-level web crawling & scraping framework for Elixir.","ref":"SpiderMan.html"},{"type":"behaviour","title":"Components - SpiderMan","doc":"Each Spider had 3 components, each component has theirs work:\n\n* [Downloader](SpiderMan.Component.Downloader.html): Download request.\n* [Spider](SpiderMan.Component.Spider.html): Analyze web pages.\n* [ItemProcessor](SpiderMan.Component.ItemProcessor.html): Store items.\n\nMessage flow: `Downloader` -> `Spider` -> `ItemProcessor`.","ref":"SpiderMan.html#module-components"},{"type":"behaviour","title":"Spider Life Cycle - SpiderMan","doc":"0. `Spider.settings()`\n  1. Prepare For Start Stage\n    1. `Spider.prepare_for_start(:pre, state)`\n    2. `Spider.prepare_for_start_component(:downloader, state)`\n    3. `Spider.prepare_for_start_component(:spider, state)`\n    4. `Spider.prepare_for_start_component(:item_processor, state)`\n    5. `Spider.prepare_for_start(:post, state)`\n  2. `Spider.init(state)`\n  3. `Spider.handle_response(response, context)`\n  4. Prepare For Stop Stage\n    1. `Spider.prepare_for_stop_component(:downloader, state)`\n    2. `Spider.prepare_for_stop_component(:spider, state)`\n    3. `Spider.prepare_for_stop_component(:item_processor, state)`\n    4. `Spider.prepare_for_stop(state)`","ref":"SpiderMan.html#module-spider-life-cycle"},{"type":"function","title":"SpiderMan.check_zero_task?/1","doc":"","ref":"SpiderMan.html#check_zero_task?/1"},{"type":"function","title":"SpiderMan.components/0","doc":"","ref":"SpiderMan.html#components/0"},{"type":"function","title":"SpiderMan.continue/2","doc":"continue a spider","ref":"SpiderMan.html#continue/2"},{"type":"function","title":"SpiderMan.ets_stats/1","doc":"fetch spider's statistics of all ets","ref":"SpiderMan.html#ets_stats/1"},{"type":"function","title":"SpiderMan.get_state/1","doc":"fetch spider's state","ref":"SpiderMan.html#get_state/1"},{"type":"callback","title":"SpiderMan.handle_response/2","doc":"","ref":"SpiderMan.html#c:handle_response/2"},{"type":"callback","title":"SpiderMan.init/1","doc":"","ref":"SpiderMan.html#c:init/1"},{"type":"function","title":"SpiderMan.insert_request/2","doc":"insert a request to spider","ref":"SpiderMan.html#insert_request/2"},{"type":"function","title":"SpiderMan.insert_requests/2","doc":"insert multiple requests to spider","ref":"SpiderMan.html#insert_requests/2"},{"type":"function","title":"SpiderMan.list_spiders/0","doc":"list spiders where already started","ref":"SpiderMan.html#list_spiders/0"},{"type":"callback","title":"SpiderMan.prepare_for_start/2","doc":"","ref":"SpiderMan.html#c:prepare_for_start/2"},{"type":"callback","title":"SpiderMan.prepare_for_start_component/2","doc":"","ref":"SpiderMan.html#c:prepare_for_start_component/2"},{"type":"callback","title":"SpiderMan.prepare_for_stop/1","doc":"","ref":"SpiderMan.html#c:prepare_for_stop/1"},{"type":"callback","title":"SpiderMan.prepare_for_stop_component/2","doc":"","ref":"SpiderMan.html#c:prepare_for_stop_component/2"},{"type":"function","title":"SpiderMan.retry_failed/3","doc":"retry failed events for a spider","ref":"SpiderMan.html#retry_failed/3"},{"type":"function","title":"SpiderMan.run_until/3","doc":"","ref":"SpiderMan.html#run_until/3"},{"type":"function","title":"SpiderMan.run_until_zero/3","doc":"","ref":"SpiderMan.html#run_until_zero/3"},{"type":"callback","title":"SpiderMan.settings/0","doc":"","ref":"SpiderMan.html#c:settings/0"},{"type":"function","title":"SpiderMan.start/2","doc":"start a spider","ref":"SpiderMan.html#start/2"},{"type":"function","title":"SpiderMan.stats/1","doc":"fetch spider's statistics","ref":"SpiderMan.html#stats/1"},{"type":"function","title":"SpiderMan.stats/2","doc":"fetch component's statistics","ref":"SpiderMan.html#stats/2"},{"type":"function","title":"SpiderMan.status/1","doc":"fetch spider's status","ref":"SpiderMan.html#status/1"},{"type":"function","title":"SpiderMan.stop/1","doc":"stop a spider","ref":"SpiderMan.html#stop/1"},{"type":"function","title":"SpiderMan.suspend/2","doc":"suspend a spider","ref":"SpiderMan.html#suspend/2"},{"type":"function","title":"SpiderMan.throughput/1","doc":"","ref":"SpiderMan.html#throughput/1"},{"type":"type","title":"SpiderMan.component/0","doc":"","ref":"SpiderMan.html#t:component/0"},{"type":"type","title":"SpiderMan.ets_stats/0","doc":"","ref":"SpiderMan.html#t:ets_stats/0"},{"type":"type","title":"SpiderMan.prepare_for_start_stage/0","doc":"","ref":"SpiderMan.html#t:prepare_for_start_stage/0"},{"type":"type","title":"SpiderMan.request/0","doc":"","ref":"SpiderMan.html#t:request/0"},{"type":"type","title":"SpiderMan.requests/0","doc":"","ref":"SpiderMan.html#t:requests/0"},{"type":"type","title":"SpiderMan.settings/0","doc":"* `:print_stats` (`t:boolean/0`) - Print the stats of spider, The default value is `true`.\n\n* `:log2file` - Save the log to files, The default value is `true`.\n\n* `:status` - Set the startup status for the spider, The default value is `:running`.\n\n* `:spider` (`t:atom/0`) - Set the callback module for the spider,\n\n* `:spider_module` (`t:atom/0`) - Set the callback module for the spider,\n\n* `:callbacks` (`t:keyword/0`)\n\n* `:ets_file` (`t:String.t/0`) - Set the filename for the spider, and load spider's state from ets files.\n\n* `:downloader_options` (`t:keyword/0`) - see [Downloader Options](#t:settings/0-downloader-options).\n\n* `:spider_options` (`t:keyword/0`) - see [Spider Options](#t:settings/0-spider-options).\n\n* `:item_processor_options` (`t:keyword/0`) - see [ItemProcessor Options](#t:settings/0-itemprocessor_options).\n\n#","ref":"SpiderMan.html#t:settings/0"},{"type":"type","title":"Downloader options - SpiderMan.settings/0","doc":"* `:requester` - The default value is `{SpiderMan.Requester.Finch, []}`.\n\n* `:producer` - The default value is `SpiderMan.Producer.ETS`.\n\n* `:context` (`t:term/0`) - The default value is `%{}`.\n\n* `:processor` (`t:keyword/0`) - See [Processors Options](https://hexdocs.pm/broadway/Broadway.html#start_link/2-processors-options), The default value is `[max_demand: 1]`.\n\n  * `:concurrency` (`t:pos_integer/0`) - The default value is `16`.\n\n  * `:min_demand` (`t:non_neg_integer/0`)\n\n  * `:max_demand` (`t:non_neg_integer/0`) - The default value is `10`.\n\n  * `:partition_by` (function of arity 1)\n\n  * `:spawn_opt` (`t:keyword/0`)\n\n  * `:hibernate_after` (`t:pos_integer/0`)\n\n* `:rate_limiting` - See [Producers Options - rate_limiting](https://hexdocs.pm/broadway/Broadway.html#start_link/2-producers-options), The default value is `[allowed_messages: 10, interval: 1000]`.\n\n* `:pipelines` - Each msg will handle by each pipelines, The default value is `[SpiderMan.Pipeline.DuplicateFilter]`.\n\n* `:post_pipelines` - Each msg will handle by each pipelines, The default value is `[SpiderMan.Pipeline.DuplicateFilter]`.\n\n#","ref":"SpiderMan.html#t:settings/0-downloader-options"},{"type":"type","title":"Spider options - SpiderMan.settings/0","doc":"* `:producer` - The default value is `SpiderMan.Producer.ETS`.\n\n* `:context` (`t:term/0`) - The default value is `%{}`.\n\n* `:processor` (`t:keyword/0`) - See [Processors Options](https://hexdocs.pm/broadway/Broadway.html#start_link/2-processors-options), The default value is `[max_demand: 1]`.\n\n  * `:concurrency` (`t:pos_integer/0`) - The default value is `16`.\n\n  * `:min_demand` (`t:non_neg_integer/0`)\n\n  * `:max_demand` (`t:non_neg_integer/0`) - The default value is `10`.\n\n  * `:partition_by` (function of arity 1)\n\n  * `:spawn_opt` (`t:keyword/0`)\n\n  * `:hibernate_after` (`t:pos_integer/0`)\n\n* `:rate_limiting` - See [Producers Options - rate_limiting](https://hexdocs.pm/broadway/Broadway.html#start_link/2-producers-options),\n\n* `:pipelines` - Each msg will handle by each pipelines, The default value is `[]`.\n\n* `:post_pipelines` - Each msg will handle by each pipelines, The default value is `[]`.\n\n##","ref":"SpiderMan.html#t:settings/0-spider-options"},{"type":"type","title":"Batchers options - SpiderMan.settings/0","doc":"* `:concurrency` (`t:pos_integer/0`) - The default value is `1`.\n\n* `:batch_size` (`t:pos_integer/0`) - The default value is `100`.\n\n* `:batch_timeout` (`t:pos_integer/0`) - The default value is `1000`.\n\n* `:partition_by` (function of arity 1)\n\n* `:spawn_opt` (`t:keyword/0`)\n\n* `:hibernate_after` (`t:pos_integer/0`)\n\n#","ref":"SpiderMan.html#t:settings/0-batchers-options"},{"type":"type","title":"ItemProcessor options - SpiderMan.settings/0","doc":"* `:storage` - Set a storage module what are store items, The default value is `SpiderMan.Storage.JsonLines`.\n\n* `:batchers` (`t:keyword/0`) - See [Batchers Options](https://hexdocs.pm/broadway/Broadway.html#start_link/2-batchers-options), The default value is `[default: [concurrency: 1, batch_size: 50, batch_timeout: 1000]]`.\n\n* `:producer` - The default value is `SpiderMan.Producer.ETS`.\n\n* `:context` (`t:term/0`) - The default value is `%{}`.\n\n* `:processor` (`t:keyword/0`) - See [Processors Options](https://hexdocs.pm/broadway/Broadway.html#start_link/2-processors-options), The default value is `[]`.\n\n  * `:concurrency` (`t:pos_integer/0`) - The default value is `16`.\n\n  * `:min_demand` (`t:non_neg_integer/0`)\n\n  * `:max_demand` (`t:non_neg_integer/0`) - The default value is `10`.\n\n  * `:partition_by` (function of arity 1)\n\n  * `:spawn_opt` (`t:keyword/0`)\n\n  * `:hibernate_after` (`t:pos_integer/0`)\n\n* `:rate_limiting` - See [Producers Options - rate_limiting](https://hexdocs.pm/broadway/Broadway.html#start_link/2-producers-options),\n\n* `:pipelines` - Each msg will handle by each pipelines, The default value is `[SpiderMan.Pipeline.DuplicateFilter]`.\n\n* `:post_pipelines` - Each msg will handle by each pipelines, The default value is `[SpiderMan.Pipeline.DuplicateFilter]`.","ref":"SpiderMan.html#t:settings/0-itemprocessor-options"},{"type":"type","title":"SpiderMan.spider/0","doc":"","ref":"SpiderMan.html#t:spider/0"},{"type":"type","title":"SpiderMan.status/0","doc":"","ref":"SpiderMan.html#t:status/0"},{"type":"module","title":"SpiderMan.CommonSpider","doc":"A Common Spider what setting functions as callbacks instead of module defined","ref":"SpiderMan.CommonSpider.html"},{"type":"module","title":"Usage - SpiderMan.CommonSpider","doc":"SpiderMan.CommonSpider.start(:spider_name, handle_response: fn response, context -> %{} end)","ref":"SpiderMan.CommonSpider.html#module-usage"},{"type":"function","title":"SpiderMan.CommonSpider.check_callbacks_and_merge_settings/2","doc":"","ref":"SpiderMan.CommonSpider.html#check_callbacks_and_merge_settings/2"},{"type":"function","title":"SpiderMan.CommonSpider.start/3","doc":"","ref":"SpiderMan.CommonSpider.html#start/3"},{"type":"type","title":"SpiderMan.CommonSpider.callback/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:callback/0"},{"type":"type","title":"SpiderMan.CommonSpider.callbacks/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:callbacks/0"},{"type":"type","title":"SpiderMan.CommonSpider.handle_response/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:handle_response/0"},{"type":"type","title":"SpiderMan.CommonSpider.init/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:init/0"},{"type":"type","title":"SpiderMan.CommonSpider.prepare_for_start/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:prepare_for_start/0"},{"type":"type","title":"SpiderMan.CommonSpider.prepare_for_start_component/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:prepare_for_start_component/0"},{"type":"type","title":"SpiderMan.CommonSpider.prepare_for_stop/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:prepare_for_stop/0"},{"type":"type","title":"SpiderMan.CommonSpider.prepare_for_stop_component/0","doc":"","ref":"SpiderMan.CommonSpider.html#t:prepare_for_stop_component/0"},{"type":"module","title":"SpiderMan.Configuration","doc":"Handle settings for spider","ref":"SpiderMan.Configuration.html"},{"type":"module","title":"Startup Spiders - SpiderMan.Configuration","doc":"config :spider_man, :spiders, [\n      SpiderA,\n      {SpiderB, settings = [...]},\n      ...\n    ]\n\nAll Spider what defined on `:spiders` would auto startup while the `:spider_man` application started.","ref":"SpiderMan.Configuration.html#module-startup-spiders"},{"type":"module","title":"Global Settings - SpiderMan.Configuration","doc":"config :spider_man, global_settings: settings = [...]\n\nThis `settings` work for all spiders.","ref":"SpiderMan.Configuration.html#module-global-settings"},{"type":"module","title":"Settings for Spider on config files - SpiderMan.Configuration","doc":"config :spider_man, SpiderA, settings = [...]\n\nThis `settings` only work for `SpiderA`.","ref":"SpiderMan.Configuration.html#module-settings-for-spider-on-config-files"},{"type":"module","title":"Default Settings - SpiderMan.Configuration","doc":"```elixir\n[\n  downloader_options: [\n    producer: SpiderMan.Producer.ETS,\n    processor: [max_demand: 1],\n    rate_limiting: [allowed_messages: 10, interval: 1000],\n    pipelines: [SpiderMan.Pipeline.DuplicateFilter],\n    post_pipelines: [],\n    context: %{}\n  ],\n  spider_options: [\n    producer: SpiderMan.Producer.ETS,\n    processor: [max_demand: 1],\n    pipelines: [],\n    post_pipelines: [],\n    context: %{}\n  ],\n  item_processor_options: [\n    producer: SpiderMan.Producer.ETS,\n    storage: SpiderMan.Storage.JsonLines,\n    pipelines: [SpiderMan.Pipeline.DuplicateFilter],\n    post_pipelines: [],\n    context: %{},\n    batchers: [default: [concurrency: 1, batch_size: 50, batch_timeout: 1000]]\n  ]\n]\n```","ref":"SpiderMan.Configuration.html#module-default-settings"},{"type":"module","title":"Settings Priority - SpiderMan.Configuration","doc":"1. Settings for Spider directly.\n  1.1 `settings` defined in `spiders` for the Spider.\n  1.2 As second argument while call `SpiderMan.start/2`.\n2. Return by callback function: `SpiderModule.settings/0`.\n3. Settings for Spider on config files.\n4. Global Settings.\n5. Default Settings.","ref":"SpiderMan.Configuration.html#module-settings-priority"},{"type":"function","title":"SpiderMan.Configuration.configuration_docs/0","doc":"","ref":"SpiderMan.Configuration.html#configuration_docs/0"},{"type":"function","title":"SpiderMan.Configuration.configuration_spec/0","doc":"","ref":"SpiderMan.Configuration.html#configuration_spec/0"},{"type":"function","title":"SpiderMan.Configuration.validate_pipeline/1","doc":"","ref":"SpiderMan.Configuration.html#validate_pipeline/1"},{"type":"function","title":"SpiderMan.Configuration.validate_settings!/2","doc":"","ref":"SpiderMan.Configuration.html#validate_settings!/2"},{"type":"module","title":"SpiderMan.Engine","doc":"Engine","ref":"SpiderMan.Engine.html"},{"type":"function","title":"SpiderMan.Engine.dump2file/3","doc":"dump spider's ets tables to files","ref":"SpiderMan.Engine.html#dump2file/3"},{"type":"function","title":"SpiderMan.Engine.dump2file_force/3","doc":"dump spider's ets tables to files, don't need confirm","ref":"SpiderMan.Engine.html#dump2file_force/3"},{"type":"type","title":"SpiderMan.Engine.state/0","doc":"","ref":"SpiderMan.Engine.html#t:state/0"},{"type":"module","title":"SpiderMan.Item","doc":"Item Struct","ref":"SpiderMan.Item.html"},{"type":"type","title":"SpiderMan.Item.t/0","doc":"","ref":"SpiderMan.Item.html#t:t/0"},{"type":"module","title":"SpiderMan.Middleware.UserAgent","doc":"Setting user-agent for request","ref":"SpiderMan.Middleware.UserAgent.html"},{"type":"module","title":"Usage - SpiderMan.Middleware.UserAgent","doc":"settings = [\n      downloader_options: [requester: {SpiderMan.Requester.Finch, [\n        middlewares: [\n        {SpiderMan.Middleware.UserAgent,\n         [\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.93 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.114 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.82 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4389.82 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4389.82 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36\"\n         ]}],\n         ...\n      ]}]\n    ]","ref":"SpiderMan.Middleware.UserAgent.html#module-usage"},{"type":"module","title":"SpiderMan.Producer.ETS","doc":"ETS Producer","ref":"SpiderMan.Producer.ETS.html"},{"type":"function","title":"SpiderMan.Producer.ETS.transform/2","doc":"","ref":"SpiderMan.Producer.ETS.html#transform/2"},{"type":"module","title":"SpiderMan.Request","doc":"Request Struct","ref":"SpiderMan.Request.html"},{"type":"type","title":"SpiderMan.Request.t/0","doc":"","ref":"SpiderMan.Request.html#t:t/0"},{"type":"behaviour","title":"SpiderMan.Requester","doc":"A Requester use by downloader component","ref":"SpiderMan.Requester.html"},{"type":"function","title":"SpiderMan.Requester.append_default_middlewares/2","doc":"","ref":"SpiderMan.Requester.html#append_default_middlewares/2"},{"type":"function","title":"SpiderMan.Requester.prepare_for_start/1","doc":"","ref":"SpiderMan.Requester.html#prepare_for_start/1"},{"type":"callback","title":"SpiderMan.Requester.prepare_for_start/2","doc":"","ref":"SpiderMan.Requester.html#c:prepare_for_start/2"},{"type":"function","title":"SpiderMan.Requester.prepare_for_stop/1","doc":"","ref":"SpiderMan.Requester.html#prepare_for_stop/1"},{"type":"callback","title":"SpiderMan.Requester.prepare_for_stop/1","doc":"","ref":"SpiderMan.Requester.html#c:prepare_for_stop/1"},{"type":"callback","title":"SpiderMan.Requester.request/3","doc":"","ref":"SpiderMan.Requester.html#c:request/3"},{"type":"module","title":"SpiderMan.Response","doc":"Response Struct","ref":"SpiderMan.Response.html"},{"type":"type","title":"SpiderMan.Response.t/0","doc":"","ref":"SpiderMan.Response.html#t:t/0"},{"type":"module","title":"SpiderMan.Utils","doc":"Utils","ref":"SpiderMan.Utils.html"},{"type":"function","title":"SpiderMan.Utils.build_item/4","doc":"build a item","ref":"SpiderMan.Utils.html#build_item/4"},{"type":"function","title":"SpiderMan.Utils.build_items/3","doc":"build items","ref":"SpiderMan.Utils.html#build_items/3"},{"type":"function","title":"SpiderMan.Utils.build_request/3","doc":"build a request","ref":"SpiderMan.Utils.html#build_request/3"},{"type":"function","title":"SpiderMan.Utils.build_requests/3","doc":"build requests","ref":"SpiderMan.Utils.html#build_requests/3"},{"type":"function","title":"SpiderMan.Utils.set_flag/2","doc":"set flag for request|response|item","ref":"SpiderMan.Utils.html#set_flag/2"},{"type":"function","title":"SpiderMan.Utils.set_key/2","doc":"set key for request|response|item","ref":"SpiderMan.Utils.html#set_key/2"},{"type":"type","title":"SpiderMan.Utils.max_retries/0","doc":"","ref":"SpiderMan.Utils.html#t:max_retries/0"},{"type":"type","title":"SpiderMan.Utils.options/0","doc":"","ref":"SpiderMan.Utils.html#t:options/0"},{"type":"type","title":"SpiderMan.Utils.url/0","doc":"","ref":"SpiderMan.Utils.html#t:url/0"},{"type":"type","title":"SpiderMan.Utils.urls/0","doc":"","ref":"SpiderMan.Utils.html#t:urls/0"},{"type":"module","title":"SpiderMan.Component.Downloader","doc":"Download request.\n\nLife cycle of request:\n  0. insert requests to ets of downloader component.\n  1. component's producer get pass out to processes.\n  2. processes handle message.\n    1. handle by pre pipelines.\n    2. call `Requester.request/3`.\n    3. handle by post pipelines.\n  3. pass out message.\n    1. if success, pass out to Spider component's ets.\n    2. if failed, maybe try again.","ref":"SpiderMan.Component.Downloader.html"},{"type":"function","title":"SpiderMan.Component.Downloader.start_link/1","doc":"","ref":"SpiderMan.Component.Downloader.html#start_link/1"},{"type":"module","title":"SpiderMan.Component.ItemProcessor","doc":"Store items.\n\nLife cycle of request:\n  0. insert requests to ets of downloader.\n  1. downloader's producer get pass out to processes.\n  2. processes handle message.\n    1. handle by pre pipelines.\n    2. call `Requester.request/3`.\n    3. handle by post pipelines.\n  3. pass out message.\n    1. if success, pass out to Batchers.\n    2. if failed, maybe try again.\n  4. batcher get enough message and call `handle_batch/4`.\n    1. call `Storage.store/3` to save items.\n    2. if success, done.\n    3. if failed, maybe try again.","ref":"SpiderMan.Component.ItemProcessor.html"},{"type":"function","title":"SpiderMan.Component.ItemProcessor.start_link/1","doc":"","ref":"SpiderMan.Component.ItemProcessor.html#start_link/1"},{"type":"module","title":"SpiderMan.Component.Spider","doc":"Analyze web pages.\n\nLife cycle of request:\n  0. insert responses to ets of spider component.\n  1. component's producer get pass out to processes.\n  2. processes handle message.\n    1. handle by pre pipelines.\n    2. call `SpiderModule.handle_response/2`.\n  3. pass out message.\n    1. if success, pass out requests to Downloader component's ets.\n    1. if success, pass out items to ItemProcessor component's ets.\n    2. if failed, maybe try again.","ref":"SpiderMan.Component.Spider.html"},{"type":"function","title":"SpiderMan.Component.Spider.start_link/1","doc":"","ref":"SpiderMan.Component.Spider.html#start_link/1"},{"type":"module","title":"SpiderMan.Pipeline.Counter","doc":"msg counter for component","ref":"SpiderMan.Pipeline.Counter.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.Counter","doc":"settings = [\n      *_options: [\n        pipelines: [SpiderMan.Pipeline.Counter | {SpiderMan.Pipeline.Counter, scope}]\n      ],\n      ...\n    ]\n\nSupport for all component: `downloader` | `spider` | `item_processor`.\n\n#","ref":"SpiderMan.Pipeline.Counter.html#module-usage"},{"type":"module","title":"Scope - SpiderMan.Pipeline.Counter","doc":"* `:common` | `[scope: :common]`: save counter to `common_pipeline_tid`.\n* `:pipeline` | `[scope: :pipeline]`:  save counter to `pipeline_tid`.\n\n`common_pipeline_tid` use by all component, `pipeline_tid` only use by one component.","ref":"SpiderMan.Pipeline.Counter.html#module-scope"},{"type":"function","title":"SpiderMan.Pipeline.Counter.get/1","doc":"","ref":"SpiderMan.Pipeline.Counter.html#get/1"},{"type":"module","title":"SpiderMan.Pipeline.Debug","doc":"use for debug msg by component","ref":"SpiderMan.Pipeline.Debug.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.Debug","doc":"settings = [\n      *_options: [\n        pipelines: [SpiderMan.Pipeline.Debug | {SpiderMan.Pipeline.Debug, log_prefix :: String.t()}]\n      ],\n      ...\n    ]\n\nSupport for all component: `downloader` | `spider` | `item_processor`.","ref":"SpiderMan.Pipeline.Debug.html#module-usage"},{"type":"module","title":"SpiderMan.Pipeline.DuplicateFilter","doc":"filter msg while duplicate key","ref":"SpiderMan.Pipeline.DuplicateFilter.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.DuplicateFilter","doc":"settings = [\n      *_options: [\n        pipelines: [SpiderMan.Pipeline.DuplicateFilter | {SpiderMan.Pipeline.DuplicateFilter, scope}]\n      ],\n      ...\n    ]\n\nSupport for all component: `downloader` | `spider` | `item_processor`.\n\n#","ref":"SpiderMan.Pipeline.DuplicateFilter.html#module-usage"},{"type":"module","title":"Scope - SpiderMan.Pipeline.DuplicateFilter","doc":"* `:common` | `[scope: :common]`: save key to `common_pipeline_tid`.\n* `:pipeline` | `[scope: :pipeline]`:  save key to `pipeline_tid`.\n\n`common_pipeline_tid` use by all component, `pipeline_tid` only use by one component.","ref":"SpiderMan.Pipeline.DuplicateFilter.html#module-scope"},{"type":"module","title":"SpiderMan.Pipeline.JsonEncode","doc":"Encode item.value to json for ItemProcessor component","ref":"SpiderMan.Pipeline.JsonEncode.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.JsonEncode","doc":"settings = [\n      item_processor_options: [\n        pipelines: [SpiderMan.Pipeline.JsonEncode | {SpiderMan.Pipeline.JsonEncode, encode_opts}]\n      ],\n      ...\n    ]","ref":"SpiderMan.Pipeline.JsonEncode.html#module-usage"},{"type":"module","title":"SpiderMan.Pipeline.JsonEncode2File","doc":"Encode item.value to json and save to files for ItemProcessor component","ref":"SpiderMan.Pipeline.JsonEncode2File.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.JsonEncode2File","doc":"settings = [\n      item_processor_options: [\n        pipelines: [SpiderMan.Pipeline.JsonEncode2File | {SpiderMan.Pipeline.JsonEncode2File, dir | [dir: dir]}]\n      ],\n      ...\n    ]\n\nThe file name is equal to `item.key`.\n\nIf didn't set dir for this pipeline, the default is current dir.","ref":"SpiderMan.Pipeline.JsonEncode2File.html#module-usage"},{"type":"module","title":"SpiderMan.Pipeline.SaveToFile","doc":"A post_pipeline what is use to download file directly for downloader component","ref":"SpiderMan.Pipeline.SaveToFile.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.SaveToFile","doc":"settings = [\n      downloader_options: [\n        post_pipeline: [SpiderMan.Pipeline.SaveToFile | {SpiderMan.Pipeline.SaveToFile, dir | [dir: dir]}]\n      ],\n      ...\n    ]\n\nThe file name is equal to `request.key`.\n\nIf didn't set dir for this pipeline, the default is current dir.\n\nSet the flag for download a request:\n\n    request = build_request(\"https://www.example.com/download/file\")\n    |> set_key(\"file_name.txt\")\n    |> set_flag(:save2file)\n\n#","ref":"SpiderMan.Pipeline.SaveToFile.html#module-usage"},{"type":"module","title":"Supports Flag - SpiderMan.Pipeline.SaveToFile","doc":"* `:save2file`: Save the request.body to file and continue go to next component.\n* `:save2file_and_skip`: Just save the request.body to file and break.","ref":"SpiderMan.Pipeline.SaveToFile.html#module-supports-flag"},{"type":"module","title":"SpiderMan.Pipeline.SetCookie","doc":"auto save cookies for spider component & auto set cookie for downloader component","ref":"SpiderMan.Pipeline.SetCookie.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.SetCookie","doc":"settings = [\n      downloader_options: [\n        pipelines: [SpiderMan.Pipeline.SetCookie]\n      ],\n      spider_options: [\n        pipelines: [SpiderMan.Pipeline.SetCookie]\n      ],\n      ...\n    ]","ref":"SpiderMan.Pipeline.SetCookie.html#module-usage"},{"type":"module","title":"SpiderMan.Pipeline.Splash","doc":"use [Splash](https://splash.readthedocs.io/en/stable/) for javascript rendering service","ref":"SpiderMan.Pipeline.Splash.html"},{"type":"module","title":"Usage - SpiderMan.Pipeline.Splash","doc":"settings = [\n      downloader_options: [\n        pipelines: [SpiderMan.Pipeline.Splash | {SpiderMan.Pipeline.Splash, %{url: \"http://localhost:8050/render.html\", query: query_for_splash}}]\n      ],\n      ...\n    ]\n\nIf didn't set dir for this pipeline, the default is `%{url: \"http://localhost:8050/render.html\", query: []}`.","ref":"SpiderMan.Pipeline.Splash.html#module-usage"},{"type":"module","title":"SpiderMan.Requester.Finch","doc":"use Finch as Requester","ref":"SpiderMan.Requester.Finch.html"},{"type":"function","title":"SpiderMan.Requester.Finch.default_options/0","doc":"","ref":"SpiderMan.Requester.Finch.html#default_options/0"},{"type":"function","title":"SpiderMan.Requester.Finch.handle_proxy_option/1","doc":"","ref":"SpiderMan.Requester.Finch.html#handle_proxy_option/1"},{"type":"module","title":"SpiderMan.Requester.Hackney","doc":"use Hackney as Requester","ref":"SpiderMan.Requester.Hackney.html"},{"type":"module","title":"SpiderMan.Storage.CSV","doc":"Save items to *.csv files by Storage","ref":"SpiderMan.Storage.CSV.html"},{"type":"module","title":"Usage - SpiderMan.Storage.CSV","doc":"settings = [\n      ...\n      item_processor_options: [\n        storage: [{SpiderMan.Storage.CSV, [headers: headers, file: file_name]}]\n      ]\n    ]\n\nIf didn't set `:file` for this Storage, the default is `./data/[Spider]_[Second].csv`,\nfor example: `./data/spider_name_1707293252.csv`.","ref":"SpiderMan.Storage.CSV.html#module-usage"},{"type":"module","title":"SpiderMan.Storage.ETS","doc":"Save items to *.ets file by Storage","ref":"SpiderMan.Storage.ETS.html"},{"type":"module","title":"Usage - SpiderMan.Storage.ETS","doc":"settings = [\n      ...\n      item_processor_options: [\n        storage: [SpiderMan.Storage.ETS | {SpiderMan.Storage.ETS, file_name}]\n      ]\n    ]\n\nIf didn't set `file_name` for this Storage, the default is `./data/[Spider]_[Second].ets`,\nfor example: `./data/spider_name_1707293252.ets`.","ref":"SpiderMan.Storage.ETS.html#module-usage"},{"type":"module","title":"SpiderMan.Storage.JsonLines","doc":"Save items to JsonLines(*.jsonl) file by Storage","ref":"SpiderMan.Storage.JsonLines.html"},{"type":"module","title":"Usage - SpiderMan.Storage.JsonLines","doc":"settings = [\n      ...\n      item_processor_options: [\n        storage: [SpiderMan.Storage.JsonLines | {SpiderMan.Storage.JsonLines, file_name}]\n      ]\n    ]\n\nIf didn't set `file_name` for this Storage, the default is `./data/[Spider]_[Second].jsonl`,\nfor example: `./data/spider_name_1707293252.jsonl`.","ref":"SpiderMan.Storage.JsonLines.html#module-usage"},{"type":"module","title":"SpiderMan.Storage.Log","doc":"Just log each item by Logger","ref":"SpiderMan.Storage.Log.html"},{"type":"module","title":"Usage - SpiderMan.Storage.Log","doc":"settings = [\n      ...\n      item_processor_options: [\n        storage: [SpiderMan.Storage.Log]\n      ]\n    ]","ref":"SpiderMan.Storage.Log.html#module-usage"},{"type":"module","title":"SpiderMan.Storage.Multi","doc":"Support setting multiple Storage for ItemProcessor component","ref":"SpiderMan.Storage.Multi.html"},{"type":"module","title":"Usage - SpiderMan.Storage.Multi","doc":"settings = [\n      ...\n      item_processor_options: [\n        storage: [SpiderMan.Storage.ETS, SpiderMan.Storage.JsonLines, ...]\n      ]\n    ]","ref":"SpiderMan.Storage.Multi.html#module-usage"},{"type":"extras","title":"License","doc":"# Apache License\nVersion 2.0, January 2004\n\nhttp://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions. - License","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License. - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License. - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution. - License","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions. - License","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks. - License","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty. - License","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability. - License","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability. - License","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS","ref":"license.html#9-accepting-warranty-or-additional-liability"},{"type":"extras","title":"Overview","doc":"# SpiderMan\n\n[![Module Version](https://img.shields.io/hexpm/v/spider_man.svg)](https://hex.pm/packages/spider_man)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/spider_man/)\n[![Total Download](https://img.shields.io/hexpm/dt/spider_man.svg)](https://hex.pm/packages/spider_man)\n[![License](https://img.shields.io/hexpm/l/spider_man.svg)](https://github.com/feng19/spider_man/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/feng19/spider_man.svg)](https://github.com/feng19/spider_man/commits/master)\n\n**SpiderMan,a fast high-level web crawling & scraping framework for Elixir.**\n\nInspired by [Crawly](https://github.com/elixir-crawly/crawly)(Elixir) and [Scrapy](https://github.com/scrapy/scrapy)(Python).","ref":"readme.html"},{"type":"extras","title":"Usage - Overview","doc":"This example show how to crawly data from\n[elixir-jobs](https://elixirjobs.net/) website by use SpiderMan.\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Use in livebook - Overview","doc":"[![Run in Livebook](https://livebook.dev/badge/v1/blue.svg)](https://livebook.dev/run?url=https%3A%2F%2Fhexdocs.pm%2Fspider_man%2Felixirjobs.livemd)\n\n#","ref":"readme.html#use-in-livebook"},{"type":"extras","title":"Use in script or mix project - Overview","doc":"```elixir\nMix.install([\n  {:spider_man, \"~> 0.6\"},\n  {:floki, \"~> 0.34\"},\n  {:nimble_csv, \"~> 1.2\"}\n])\n\ndefmodule SpiderList.ElixirJobs do\n  @moduledoc false\n  use SpiderMan\n  require Logger\n  alias SpiderMan.Response\n\n  @base_url \"https://elixirjobs.net/\"\n\n  def run do\n    SpiderMan.run_until_zero(__MODULE__, [], 3_000)\n  end\n\n  @impl true\n  def settings do\n    requester_options = [\n      base_url: @base_url,\n      middlewares: [\n        {SpiderMan.Middleware.UserAgent,\n         [\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.93 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.114 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.82 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4389.82 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4389.82 Safari/537.36\",\n           \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36\"\n         ]},\n        {Tesla.Middleware.Headers,\n         [\n           {\"referer\", @base_url},\n           {\"accept\",\n            \"text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9\"},\n           {\"accept-encoding\", \"gzip, deflate\"},\n           {\"accept-language\", \"zh-CN,zh;q=0.9,zh-TW;q=0.8,en;q=0.7\"}\n         ]},\n        Tesla.Middleware.DecompressResponse\n      ]\n    ]\n\n    [\n      downloader_options: [requester: {SpiderMan.Requester.Finch, requester_options}],\n      spider_options: [pipelines: []],\n      item_processor_options: [\n        storage: [\n          {SpiderMan.Storage.ETS, \"./data/jobs.ets\"},\n          {SpiderMan.Storage.CSV,\n           file: \"./data/jobs.csv\",\n           headers: [\n             :link,\n             :title,\n             :sub_title,\n             :date,\n             :workplace,\n             :type\n           ]}\n        ]\n      ]\n    ]\n  end\n\n  @impl true\n  def init(state) do\n    build_request(@base_url)\n    |> set_flag(:first_page)\n    |> then(&SpiderMan.insert_request(__MODULE__, &1))\n\n    state\n  end\n\n  @impl true\n  def handle_response(%Response{env: env, flag: :first_page}, _context) do\n    total_page =\n      Regex.run(~r/Showing page 1 of (\\d+)/, env.body, capture: :all_but_first)\n      |> hd()\n      |> String.to_integer()\n\n    Logger.info(\"total: #{total_page}\")\n\n    requests =\n      Enum.map(2..total_page, fn n ->\n        build_request(\"/?page=#{n}\")\n        |> set_flag({:list_page, n})\n      end)\n\n    handle_list_page(env.body, 1)\n    |> Map.put(:requests, requests)\n  end\n\n  def handle_response(%Response{env: env, flag: {:list_page, n}}, _context) do\n    handle_list_page(env.body, n)\n  end\n\n  defp handle_list_page(body, n) do\n    Logger.info(\"processing page #{n}\")\n    {:ok, document} = Floki.parse_document(body)\n\n    jobs =\n      Floki.find(document, \".offers-index\")\n      |> hd()\n      |> Floki.children(include_text: false)\n      |> Enum.filter(&match?({\"a\", _, _}, &1))\n\n    items =\n      Enum.map(jobs, fn job ->\n        title = Floki.find(job, \".title strong\") |> Floki.text() |> String.trim()\n        sub_title = Floki.find(job, \".title small\") |> Floki.text() |> String.trim()\n        link = Floki.attribute(job, \"a\", \"href\") |> hd()\n\n        [_, date, _, workplace, _, type] =\n          Floki.find(job, \".control .tag\")\n          |> Enum.map(&(&1 |> Floki.text() |> String.trim()))\n\n        build_item(\n          link,\n          %{\n            link: @base_url <> String.slice(link, 1..-1),\n            title: title,\n            sub_title: sub_title,\n            date: date,\n            workplace: workplace,\n            type: type\n          }\n        )\n      end)\n\n    %{items: items}\n  end\nend\n\nSpiderList.ElixirJobs.run()\n```\n\ncopy this script and save to `elixir_jobs.exs` and then start by command:\n```shell\nelixir elixir_jobs.exs\n```","ref":"readme.html#use-in-script-or-mix-project"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2023 feng19\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Livebook Case","doc":"# ElixirJobs\n\n```elixir\nMix.install([\n  {:spider_man, \"~> 0.6\"},\n  {:floki, \"~> 0.34\"},\n  {:nimble_csv, \"~> 1.2\"},\n  {:kino, \"~> 0.12\"}\n])\n```","ref":"elixirjobs.html"},{"type":"extras","title":"Config the spider - Livebook Case","doc":"```elixir\nspider = SpiderList.ElixirJobs\nbase_url = \"https://elixirjobs.net/\"\n\nrequester_options = [\n  base_url: base_url,\n  middlewares: [\n    {SpiderMan.Middleware.UserAgent,\n     [\n       \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.93 Safari/537.36\",\n       \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.114 Safari/537.36\",\n       \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.82 Safari/537.36\",\n       \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4389.82 Safari/537.36\",\n       \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4389.82 Safari/537.36\",\n       \"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36\"\n     ]},\n    {Tesla.Middleware.Headers,\n     [\n       {\"referer\", base_url},\n       {\"accept\",\n        \"text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9\"},\n       {\"accept-encoding\", \"gzip, deflate\"},\n       {\"accept-language\", \"zh-CN,zh;q=0.9,zh-TW;q=0.8,en;q=0.7\"}\n     ]},\n    Tesla.Middleware.DecompressResponse\n  ]\n]\n\nsettings = [\n  log2file: false,\n  print_stats: false,\n  downloader_options: [requester: {SpiderMan.Requester.Finch, requester_options}],\n  spider_options: [pipelines: []],\n  item_processor_options: [\n    storage: [\n      {SpiderMan.Storage.ETS, %{file_path: \"./data/jobs.ets\", give_away: {self(), :got_data}}},\n      {SpiderMan.Storage.CSV,\n       file: \"./data/jobs.csv\",\n       headers: [\n         :link,\n         :title,\n         :sub_title,\n         :date,\n         :workplace,\n         :type\n       ]}\n    ]\n  ]\n]\n```","ref":"elixirjobs.html#config-the-spider"},{"type":"extras","title":"Code for spider - Livebook Case","doc":"```elixir\nimport SpiderMan\nimport SpiderMan.Utils\nrequire Logger\n\ninit = fn state ->\n  build_request(base_url)\n  |> set_flag(:first_page)\n  |> then(&SpiderMan.insert_request(spider, &1))\n\n  state\nend\n\ntoday = Date.from_erl!(:erlang.date())\nutc_now = DateTime.utc_now()\n\nmonths =\n  Map.new(\n    1..12,\n    &{\n      Calendar.strftime(%{utc_now | month: &1}, \"%b\"),\n      if(&1 >= 10, do: &1, else: \"0#{&1}\")\n    }\n  )\n\nparse_date = fn\n  \"Today\" ->\n    today\n\n  \"Yesterday\" ->\n    Date.add(today, -1)\n\n  date ->\n    case String.split(date) do\n      [day, month] ->\n        month = months[month]\n        [today.year, month, day]\n\n      [day, month, year] ->\n        month = months[month]\n        [year, month, day]\n    end\n    |> case do\n      [year, month, <<_>> = day] ->\n        Date.from_iso8601!(\"#{year}-#{month}-0#{day}\")\n\n      [year, month, day] ->\n        Date.from_iso8601!(\"#{year}-#{month}-#{day}\")\n    end\nend\n\nhandle_list_page = fn body, n ->\n  Logger.info(\"processing page #{n}\")\n  {:ok, document} = Floki.parse_document(body)\n\n  jobs =\n    Floki.find(document, \".offers-index\")\n    |> hd()\n    |> Floki.children(include_text: false)\n    |> Enum.filter(&match?({\"a\", _, _}, &1))\n\n  items =\n    Enum.map(jobs, fn job ->\n      title = Floki.find(job, \".title strong\") |> Floki.text() |> String.trim()\n      sub_title = Floki.find(job, \".title small\") |> Floki.text() |> String.trim()\n      link = Floki.attribute(job, \"a\", \"href\") |> hd()\n\n      [_, date, _, workplace, _, type] =\n        Floki.find(job, \".control .tag\")\n        |> Enum.map(&(&1 |> Floki.text() |> String.trim()))\n\n      build_item(\n        link,\n        %{\n          link: base_url <> String.slice(link, 1..-1),\n          title: title,\n          sub_title: sub_title,\n          date: parse_date.(date),\n          workplace: workplace,\n          type: type\n        }\n      )\n    end)\n\n  %{items: items}\nend\n\nhandle_response = fn\n  %{env: env, flag: :first_page}, _context ->\n    total_page =\n      Regex.run(~r/Showing page 1 of (\\d+)/, env.body, capture: :all_but_first)\n      |> hd()\n      |> String.to_integer()\n\n    Logger.info(\"total: #{total_page}\")\n\n    requests =\n      Enum.map(2..total_page, fn n ->\n        build_request(\"/?page=#{n}\")\n        |> set_flag({:list_page, n})\n      end)\n\n    handle_list_page.(env.body, 1)\n    |> Map.put(:requests, requests)\n\n  %{env: env, flag: {:list_page, n}}, _context ->\n    handle_list_page.(env.body, n)\nend\n\ncallbacks = [init: init, handle_response: handle_response]\n{:ok, settings} = SpiderMan.CommonSpider.check_callbacks_and_merge_settings(callbacks, settings)\nsettings\n```","ref":"elixirjobs.html#code-for-spider"},{"type":"extras","title":"Run it! - Livebook Case","doc":"```elixir\n# clean old data\nFile.ls!(\"data\") |> Enum.each(&File.rm!(\"data/#{&1}\"))\n\nframe = Kino.Frame.new()\nKino.render(frame)\nbutton = Kino.Control.button(\"Run it!\")\nKino.Frame.render(frame, button)\n\nKino.listen(button, fn _event ->\n  md = Kino.Markdown.new(\"**Waiting...**\")\n  Kino.Frame.render(frame, md)\n  {:ok, _} = SpiderMan.start(spider, settings)\n  Process.sleep(2000)\n\n  Kino.listen(1000, 2, fn _e, acc ->\n    if SpiderMan.check_zero_task?(spider) do\n      SpiderMan.stop(spider)\n      md = Kino.Markdown.new(\"**Spider Stopped**\")\n      Kino.Frame.append(frame, md)\n      :halt\n    else\n      infos =\n        SpiderMan.throughput(spider)\n        |> Enum.map(fn info ->\n          tps = if info.tps > 999, do: \"999+\", else: info.tps\n          component = Atom.to_string(info.component) |> Macro.camelize()\n\n          \"- #{component}:[Success/Total: #{info.success}/#{info.total} tps: #{tps}/s Failed:#{info.fail}]\"\n        end)\n        |> Enum.join(\"\\n\")\n\n      md =\n        Kino.Markdown.new(\"\"\"\n        **Used: #{acc} seconds**\n        #{infos}\n        \"\"\")\n\n      Kino.Frame.render(frame, md)\n      {:cont, acc + 1}\n    end\n  end)\nend)\n\nresult_frame = Kino.Frame.new()\nmd = Kino.Markdown.new(\"**Waiting Result...**\")\nKino.Frame.render(result_frame, md)\n\nreceive do\n  {:\"ETS-TRANSFER\", tid, _old_owner, :got_data} ->\n    table =\n      :ets.tab2list(tid)\n      |> Stream.map(&elem(&1, 1))\n      |> Enum.sort_by(& &1.date, {:desc, Date})\n      |> Kino.DataTable.new(sorting_enabled: true)\n\n    Kino.Frame.render(result_frame, table)\nend\n\nresult_frame\n```","ref":"elixirjobs.html#run-it"}],"content_type":"text/markdown"}